#include <QList>
#include "addpolygon.h"
#include "model/Mediator.h"

//Metodo construtor
AddPolygon::AddPolygon(QWidget *parent)
    : QDialog(parent)
{
	ui.setupUi(this);

}

//Metodo destrutor
AddPolygon::~AddPolygon()
{

}

//Resposta ao clique no botão para adicionar o ponto que formará o poligono
void AddPolygon::on_addPointButton_clicked() {
	int rc = ui.PontosPoligono->rowCount();
	ui.PontosPoligono->setRowCount(rc + 1);
}

//Resposta ao clique no botão para remover linhas do dialog que formam a lista de pontos do poligono
void AddPolygon::on_removePointButton_clicked() {
	int r = ui.PontosPoligono->currentRow();
	ui.PontosPoligono->removeRow(r);
}

//Resposta ao clique no botão ok
void AddPolygon::on_addButtonBox_accepted() {

        QList<double> xs, ys;
        int rc = ui.PontosPoligono->rowCount();
	for(int i = 0; i < rc; i++) {
		QTableWidgetItem *x = ui.PontosPoligono->item(i,0), *y = ui.PontosPoligono->item(i,1);
                if((x != NULL) && (y != NULL)){
                    xs << x->text().toInt();
                    ys << y->text().toInt();
                }
	}
        if(!(xs.empty())&&!(ys.empty()))
            Mediator::instance()->addPolygon(xs,ys,ui.PoligonoNome->text(), ui.ckb_Preenchido->isChecked());

	close();
}
//Resposta ao clique no botão cancel
void AddPolygon::on_addButtonBox_rejected() {
	close();
}
