#include "DisplayFile.h"
#include "Point.h"

//metodo construtor
DisplayFile::DisplayFile() {
	stringList = new QStringList;
	stringListModel = new QStringListModel;
}
//metodo destrutor
DisplayFile::~DisplayFile() {
}

//metodo que adiciona o objeto a lista e emiti o sinal para atualizar na viewport
void DisplayFile::addShape(Shape* shape)
{
	shapeList.append(shape);
	*stringList << shape->getName();
	stringListModel->setStringList(*stringList);
	emit shapeAdded();
}

//metodo que captura o modelo de representação da lista
QStringListModel* DisplayFile::getStringListModel() {
	return stringListModel;
}

//metodo que retorna a lista de formas
QList<Shape*> DisplayFile::getShapes() {
	return shapeList;
}
