#include <QString>
#include "Shape.h"

//metodo construtor
Shape::Shape(shape_t type) {
	this->type = type;
        setRGB(0,0,0);
}

//metodo destrutor
Shape::~Shape() {
}

//metodo que retorna o tipo da objeto em questão
shape_t Shape::getType() const {
	return type;
}
//metodo que retorna o nome da objeto em questão
QString Shape::getName() const {
	return name;
}

//metodo que insere o nome da objeto em questão
void Shape::setName(QString id) {
	name = id;
}

//metodo que atribui as cores para o objeto
void Shape::setRGB(int R, int G, int B)
{
    this->R = R;
    this->G = G;
    this->B = B;
}
